#ifndef _H_CDD51F1CE16942C291A9D5C0ABDE8EAC_ReturnCode_DCPS_H_
#define _H_CDD51F1CE16942C291A9D5C0ABDE8EAC_ReturnCode_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ReturnCode_.h"


namespace rc_common_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ReturnCode_TypeSupportInterface;

            typedef ReturnCode_TypeSupportInterface * ReturnCode_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ReturnCode_TypeSupportInterface> ReturnCode_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ReturnCode_TypeSupportInterface> ReturnCode_TypeSupportInterface_out;


            class ReturnCode_DataWriter;

            typedef ReturnCode_DataWriter * ReturnCode_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ReturnCode_DataWriter> ReturnCode_DataWriter_var;
            typedef DDS_DCPSInterface_out < ReturnCode_DataWriter> ReturnCode_DataWriter_out;


            class ReturnCode_DataReader;

            typedef ReturnCode_DataReader * ReturnCode_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ReturnCode_DataReader> ReturnCode_DataReader_var;
            typedef DDS_DCPSInterface_out < ReturnCode_DataReader> ReturnCode_DataReader_out;


            class ReturnCode_DataReaderView;

            typedef ReturnCode_DataReaderView * ReturnCode_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ReturnCode_DataReaderView> ReturnCode_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ReturnCode_DataReaderView> ReturnCode_DataReaderView_out;

            struct ReturnCode_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ReturnCode_, struct ReturnCode_Seq_uniq_> ReturnCode_Seq;
            typedef DDS_DCPSSequence_var < ReturnCode_Seq> ReturnCode_Seq_var;
            typedef DDS_DCPSSequence_out < ReturnCode_Seq> ReturnCode_Seq_out;

            class  ReturnCode_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ReturnCode_TypeSupportInterface_ptr _ptr_type;
                typedef ReturnCode_TypeSupportInterface_var _var_type;

                static ReturnCode_TypeSupportInterface_ptr _duplicate (ReturnCode_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ReturnCode_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ReturnCode_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ReturnCode_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ReturnCode_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ReturnCode_TypeSupportInterface () {};
                ~ReturnCode_TypeSupportInterface () {};
            private:
                ReturnCode_TypeSupportInterface (const ReturnCode_TypeSupportInterface &);
                ReturnCode_TypeSupportInterface & operator = (const ReturnCode_TypeSupportInterface &);
            };

            class  ReturnCode_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ReturnCode_DataWriter_ptr _ptr_type;
                typedef ReturnCode_DataWriter_var _var_type;

                static ReturnCode_DataWriter_ptr _duplicate (ReturnCode_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ReturnCode_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ReturnCode_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ReturnCode_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ReturnCode_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ReturnCode_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ReturnCode_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ReturnCode_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ReturnCode_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ReturnCode_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ReturnCode_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ReturnCode_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ReturnCode_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ReturnCode_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ReturnCode_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ReturnCode_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ReturnCode_& instance_data) = 0;

            protected:
                ReturnCode_DataWriter () {};
                ~ReturnCode_DataWriter () {};
            private:
                ReturnCode_DataWriter (const ReturnCode_DataWriter &);
                ReturnCode_DataWriter & operator = (const ReturnCode_DataWriter &);
            };

            class  ReturnCode_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ReturnCode_DataReader_ptr _ptr_type;
                typedef ReturnCode_DataReader_var _var_type;

                static ReturnCode_DataReader_ptr _duplicate (ReturnCode_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ReturnCode_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ReturnCode_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ReturnCode_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ReturnCode_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ReturnCode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ReturnCode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ReturnCode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ReturnCode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ReturnCode_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ReturnCode_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ReturnCode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ReturnCode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ReturnCode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ReturnCode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ReturnCode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ReturnCode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ReturnCode_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ReturnCode_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ReturnCode_& instance) = 0;

            protected:
                ReturnCode_DataReader () {};
                ~ReturnCode_DataReader () {};
            private:
                ReturnCode_DataReader (const ReturnCode_DataReader &);
                ReturnCode_DataReader & operator = (const ReturnCode_DataReader &);
            };

            class  ReturnCode_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ReturnCode_DataReaderView_ptr _ptr_type;
                typedef ReturnCode_DataReaderView_var _var_type;

                static ReturnCode_DataReaderView_ptr _duplicate (ReturnCode_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ReturnCode_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ReturnCode_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ReturnCode_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ReturnCode_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ReturnCode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ReturnCode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ReturnCode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ReturnCode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ReturnCode_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ReturnCode_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ReturnCode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ReturnCode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ReturnCode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ReturnCode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ReturnCode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ReturnCode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ReturnCode_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ReturnCode_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ReturnCode_& instance) = 0;

            protected:
                ReturnCode_DataReaderView () {};
                ~ReturnCode_DataReaderView () {};
            private:
                ReturnCode_DataReaderView (const ReturnCode_DataReaderView &);
                ReturnCode_DataReaderView & operator = (const ReturnCode_DataReaderView &);
            };
        }

    }

}

#endif
