#ifndef _H_1AA609E56C32405A886884EFC331626A_CameraParam__H_
#define _H_1AA609E56C32405A886884EFC331626A_CameraParam__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"
#include "rc_common_msgs/msg/dds_opensplice/KeyValue_.h"


namespace rc_common_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  CameraParam_
            {
                struct _line_source__seq_uniq_{};
                typedef DDS_DCPSUVLSeq< ::rc_common_msgs::msg::dds_::KeyValue_, struct _line_source__seq_uniq_ > _line_source__seq;
                typedef DDS_DCPSSequence_var< _line_source__seq > _line_source__seq_var;
                typedef DDS_DCPSSequence_out< _line_source__seq > _line_source__seq_out;
                struct _extra_data__seq_uniq_{};
                typedef DDS_DCPSUVLSeq< ::rc_common_msgs::msg::dds_::KeyValue_, struct _extra_data__seq_uniq_ > _extra_data__seq;
                typedef DDS_DCPSSequence_var< _extra_data__seq > _extra_data__seq_var;
                typedef DDS_DCPSSequence_out< _extra_data__seq > _extra_data__seq_out;
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Boolean is_color_camera_;
                ::DDS::Float exposure_time_;
                ::DDS::Float gain_;
                ::DDS::ULong line_status_all_;
                _line_source__seq line_source_;
                _extra_data__seq extra_data_;
            };

            typedef DDS_DCPSStruct_var<CameraParam_> CameraParam__var;
            typedef DDS_DCPSStruct_out < CameraParam_> CameraParam__out;

        }

    }

}

#endif /* _H_1AA609E56C32405A886884EFC331626A_CameraParam__H_ */
