#ifndef _H_A44951520D76FF8571A014D9EDC79B1B_ReturnCodeConstants_DCPS_H_
#define _H_A44951520D76FF8571A014D9EDC79B1B_ReturnCodeConstants_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ReturnCodeConstants_.h"


namespace rc_common_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ReturnCodeConstants_TypeSupportInterface;

            typedef ReturnCodeConstants_TypeSupportInterface * ReturnCodeConstants_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ReturnCodeConstants_TypeSupportInterface> ReturnCodeConstants_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ReturnCodeConstants_TypeSupportInterface> ReturnCodeConstants_TypeSupportInterface_out;


            class ReturnCodeConstants_DataWriter;

            typedef ReturnCodeConstants_DataWriter * ReturnCodeConstants_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ReturnCodeConstants_DataWriter> ReturnCodeConstants_DataWriter_var;
            typedef DDS_DCPSInterface_out < ReturnCodeConstants_DataWriter> ReturnCodeConstants_DataWriter_out;


            class ReturnCodeConstants_DataReader;

            typedef ReturnCodeConstants_DataReader * ReturnCodeConstants_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ReturnCodeConstants_DataReader> ReturnCodeConstants_DataReader_var;
            typedef DDS_DCPSInterface_out < ReturnCodeConstants_DataReader> ReturnCodeConstants_DataReader_out;


            class ReturnCodeConstants_DataReaderView;

            typedef ReturnCodeConstants_DataReaderView * ReturnCodeConstants_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ReturnCodeConstants_DataReaderView> ReturnCodeConstants_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ReturnCodeConstants_DataReaderView> ReturnCodeConstants_DataReaderView_out;

            struct ReturnCodeConstants_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < ReturnCodeConstants_, struct ReturnCodeConstants_Seq_uniq_> ReturnCodeConstants_Seq;
            typedef DDS_DCPSSequence_var < ReturnCodeConstants_Seq> ReturnCodeConstants_Seq_var;
            typedef DDS_DCPSSequence_out < ReturnCodeConstants_Seq> ReturnCodeConstants_Seq_out;

            class  ReturnCodeConstants_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ReturnCodeConstants_TypeSupportInterface_ptr _ptr_type;
                typedef ReturnCodeConstants_TypeSupportInterface_var _var_type;

                static ReturnCodeConstants_TypeSupportInterface_ptr _duplicate (ReturnCodeConstants_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ReturnCodeConstants_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ReturnCodeConstants_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ReturnCodeConstants_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ReturnCodeConstants_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ReturnCodeConstants_TypeSupportInterface () {};
                ~ReturnCodeConstants_TypeSupportInterface () {};
            private:
                ReturnCodeConstants_TypeSupportInterface (const ReturnCodeConstants_TypeSupportInterface &);
                ReturnCodeConstants_TypeSupportInterface & operator = (const ReturnCodeConstants_TypeSupportInterface &);
            };

            class  ReturnCodeConstants_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ReturnCodeConstants_DataWriter_ptr _ptr_type;
                typedef ReturnCodeConstants_DataWriter_var _var_type;

                static ReturnCodeConstants_DataWriter_ptr _duplicate (ReturnCodeConstants_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ReturnCodeConstants_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ReturnCodeConstants_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ReturnCodeConstants_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ReturnCodeConstants_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ReturnCodeConstants_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ReturnCodeConstants_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ReturnCodeConstants_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ReturnCodeConstants_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ReturnCodeConstants_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ReturnCodeConstants_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ReturnCodeConstants_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ReturnCodeConstants_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ReturnCodeConstants_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ReturnCodeConstants_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ReturnCodeConstants_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ReturnCodeConstants_& instance_data) = 0;

            protected:
                ReturnCodeConstants_DataWriter () {};
                ~ReturnCodeConstants_DataWriter () {};
            private:
                ReturnCodeConstants_DataWriter (const ReturnCodeConstants_DataWriter &);
                ReturnCodeConstants_DataWriter & operator = (const ReturnCodeConstants_DataWriter &);
            };

            class  ReturnCodeConstants_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ReturnCodeConstants_DataReader_ptr _ptr_type;
                typedef ReturnCodeConstants_DataReader_var _var_type;

                static ReturnCodeConstants_DataReader_ptr _duplicate (ReturnCodeConstants_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ReturnCodeConstants_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ReturnCodeConstants_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ReturnCodeConstants_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ReturnCodeConstants_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ReturnCodeConstants_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ReturnCodeConstants_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ReturnCodeConstants_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ReturnCodeConstants_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ReturnCodeConstants_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ReturnCodeConstants_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ReturnCodeConstants_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ReturnCodeConstants_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ReturnCodeConstants_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ReturnCodeConstants_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ReturnCodeConstants_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ReturnCodeConstants_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ReturnCodeConstants_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ReturnCodeConstants_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ReturnCodeConstants_& instance) = 0;

            protected:
                ReturnCodeConstants_DataReader () {};
                ~ReturnCodeConstants_DataReader () {};
            private:
                ReturnCodeConstants_DataReader (const ReturnCodeConstants_DataReader &);
                ReturnCodeConstants_DataReader & operator = (const ReturnCodeConstants_DataReader &);
            };

            class  ReturnCodeConstants_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ReturnCodeConstants_DataReaderView_ptr _ptr_type;
                typedef ReturnCodeConstants_DataReaderView_var _var_type;

                static ReturnCodeConstants_DataReaderView_ptr _duplicate (ReturnCodeConstants_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ReturnCodeConstants_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ReturnCodeConstants_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ReturnCodeConstants_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ReturnCodeConstants_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ReturnCodeConstants_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ReturnCodeConstants_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ReturnCodeConstants_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ReturnCodeConstants_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ReturnCodeConstants_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ReturnCodeConstants_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ReturnCodeConstants_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ReturnCodeConstants_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ReturnCodeConstants_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ReturnCodeConstants_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ReturnCodeConstants_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ReturnCodeConstants_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ReturnCodeConstants_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ReturnCodeConstants_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ReturnCodeConstants_& instance) = 0;

            protected:
                ReturnCodeConstants_DataReaderView () {};
                ~ReturnCodeConstants_DataReaderView () {};
            private:
                ReturnCodeConstants_DataReaderView (const ReturnCodeConstants_DataReaderView &);
                ReturnCodeConstants_DataReaderView & operator = (const ReturnCodeConstants_DataReaderView &);
            };
        }

    }

}

#endif
